<script setup lang="ts">
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { TableColumnsType, message } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import { listBase5G } from '@/api/neUser/base5G';
import useI18n from '@/hooks/useI18n';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useNeInfoStore from '@/store/modules/neinfo';
import { useRoute } from 'vue-router';
import { ColumnsType } from 'ant-design-vue/es/table';
import TableColumnsDnd from '@/components/TableColumnsDnd/index.vue';
import { listTenant } from '@/api/system/tenant';
const neInfoStore = useNeInfoStore();
const route = useRoute();
const { t } = useI18n();

/**网元参数 */
let neCascaderOptions = ref<Record<string, any>[]>([]);

let promises = ref<any[]>([]);

/**查询参数 */
let queryParams = reactive({
  tenantNameArr: <Record<string, any>[]>[],
  /**45G类型 */
  totalType: '',
  /**网元ID */
  neId: '',
  /**网元类型 */
  neType: ['', ''],
  /**GNB_ID */
  id: '',
  /** 租户名称*/
  tenantName: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    neId: '',
    id: '',
    tenantName: '',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGet45GList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'small',
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: 'Radio ID',
    dataIndex: 'id',
    align: 'center',
    width: 100,
  },
  {
    title: 'NE Name',
    dataIndex: 'neName',
    align: 'left',
    resizable: true,
    width: 200,
    minWidth: 150,
    maxWidth: 400,
  },
  {
    title: 'UE Number',
    dataIndex: 'ueNum',
    align: 'center',
    width: 100,
  },
  {
    title: 'Radio Name',
    dataIndex: 'name',
    align: 'left',
    resizable: true,
    width: 200,
    minWidth: 150,
    maxWidth: 400,
  },
  {
    title: 'Tenant Name',
    dataIndex: 'tenantName',
    align: 'center',
    key: 'tenantName',
    width: 150,
  },
  {
    title: 'Radio Address',
    dataIndex: 'address',
    align: 'left',
  },
];

/**表格字段列排序 */
let tableColumnsDnd = ref<ColumnsType>([]);

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGet45GList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**查询4G或者5G及45G列表, pageNum初始页数 */
function fnGet45GList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  if (!queryParams.neType) {
    tableState.data = [];
    promises.value = [];
    //同时获取45G基站信息 且在每条信息中添加45G字段(原始数据没有) 已经筛选后的
    neCascaderOptions.value.map((item: any) => {
      item.children.forEach((child: any) => { 
        promises.value.push(
          listBase5G({
            neId: child.neId,
            neType: child.neType,
            nbId: queryParams.id,
            pageNum: queryParams.pageNum,
            pageSize: 10000,
          }).then(res => {
            // 添加 neName 字段到每一项数据
            if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
              res.rows.forEach(row => {
                row.neName = `${child.neType}_${child.neId}`;
              });
            }
            return res;
          })
        );
      });
    });

    Promise.allSettled(promises.value).then(results => {
      results.forEach(result => {
        if (result.status === 'fulfilled') {
          const allBaseData = result.value;
          if (
            allBaseData.code === RESULT_CODE_SUCCESS &&
            Array.isArray(allBaseData.rows)
          ) {
            // 处理成功结果
            tablePagination.total += allBaseData.total;
            tableState.data = [...tableState.data, ...allBaseData.rows];
            if (
              tablePagination.total <=
                (queryParams.pageNum - 1) * tablePagination.pageSize &&
              queryParams.pageNum !== 1
            ) {
              tableState.loading = false;
              fnGet45GList(queryParams.pageNum - 1);
            }
          } else {
            //AMF返回404是代表没找到这个数据 GNB_NOT_FOUND
            tablePagination.total = 0;
            tableState.data = [];
          }
          tableState.loading = false;
        }
      });
    });

    return;
  }

  const typeArr: any = [];
  const typeMapping: any = {
    '4g': ['MME'],
    '5g': ['AMF'],
    '45g': ['AMF', 'MME'],
  };

  typeArr.value = typeMapping[queryParams.totalType] || ['AMF', 'MME'];

  //进行筛选
  neCascaderOptions.value = neInfoStore.getNeCascaderOptions.filter(
    (item: any) => {
      return typeArr.value.includes(item.value); //包括AMF或者MME
    }
  );

  if (neCascaderOptions.value.length === 0) {
    message.warning({
      content: t('common.noData'),
      duration: 2,
    });
    return;
  }

  tableState.data = [];
  promises.value = [];

  //同时获取45G基站信息 且在每条信息中添加45G字段(原始数据没有) 已经筛选后的
  neCascaderOptions.value.map((item: any) => {
    item.children.forEach((child: any) => {
      promises.value.push(
        listBase5G({
          neId: child.neId,
          neType: child.neType,
          nbId: queryParams.id,
          tenantName: queryParams.tenantName,
          pageNum: queryParams.pageNum,
          pageSize: 10000,
        })
      );
    });
  });

  Promise.allSettled(promises.value).then(results => {
    results.forEach(result => {
      if (result.status === 'fulfilled') {
        const allBaseData = result.value;
        if (
          allBaseData.code === RESULT_CODE_SUCCESS &&
          Array.isArray(allBaseData.rows)
        ) {
          // 处理成功结果
          tablePagination.total += allBaseData.total;
          tableState.data = [...tableState.data, ...allBaseData.rows];
          if (
            tablePagination.total <=
              (queryParams.pageNum - 1) * tablePagination.pageSize &&
            queryParams.pageNum !== 1
          ) {
            tableState.loading = false;
            fnGet45GList(queryParams.pageNum - 1);
          }
        } else {
          //AMF返回404是代表没找到这个数据 GNB_NOT_FOUND
          tablePagination.total += allBaseData.total;
          tableState.data = [...tableState.data, ...allBaseData.rows];
        }
        tableState.loading = false;
      }
    });
  });
}



onMounted(() => {
  // 获取网元网元列表
  neInfoStore
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        if (res.data.length > 0) {
          // 无查询参数neType时 默认选择AMF 监控页跳转时
          queryParams.totalType = (route.query.neType as string) || '45g';
        }
      } else {
        message.warning({
          content: t('common.noData'),
          duration: 2,
        });
      }
    })
    .finally(() => {
      // 获取列表数据
      // fnGetList();
      fnGet45GList();
    });

  //查询租户
  listTenant({ parentId: 0 }).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
      queryParams.tenantNameArr = []; //上面置为空数组时会报错 故在此
      res.data.forEach((item: any) => {
        if (item.parentId === '0') {
          queryParams.tenantNameArr.push({
            value: item.tenantName,
            label: item.tenantName,
          });
        }
      });
    }
  });
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item name="neId" :label="t('views.neUser.base5G.neType')">
              <a-select
                v-model:value="queryParams.totalType"
                :options="[
                  { label: '4G', value: '4g' },
                  { label: '5G', value: '5g' },
                  { label: '4&5G', value: '45g' },
                ]"
                :allow-clear="false"
                :placeholder="t('common.selectPlease')"
                @change="fnGet45GList(1)"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item label="Radio ID" name="id">
              <a-input v-model:value="queryParams.id" allow-clear></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24" :gutter="16">
            <a-form-item
              :label="t('views.neUser.sub.tenantName')"
              name="tenantName "
            >
              <a-auto-complete
                v-model:value="queryParams.tenantName"
                :options="queryParams.tenantNameArr"
              ></a-auto-complete>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGet45GList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title> </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGet45GList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <TableColumnsDnd
            cache-id="base5GData"
            :columns="tableColumns"
            v-model:columns-dnd="tableColumnsDnd"
          ></TableColumnsDnd>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumnsDnd"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ y: 'calc(100vh - 480px)' }"
        @resizeColumn="(w:number, col:any) => (col.width = w)"
      >
      </a-table>
    </a-card>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
